#!/bin/bash

# directory setup
DIR=$(pwd)
BDIR="$(pwd)/static_binaries"
TMPDIR=$(mktemp -d)
trap "{ rm -rf $TMPDIR; }" EXIT
cp . "$TMPDIR" -r

mkdir -p $BDIR

cd $TMPDIR \
&& cabal clean \
&& cabal update \
&& cabal build -j --enable-executable-static --enable-executable-stripping \
&& find dist-newstyle/ -name crest-cr -type f -exec cp {} "$BDIR" \; \
&& find dist-newstyle/ -name crest-sn -type f -exec cp {} "$BDIR" \; \
&& find dist-newstyle/ -name crest-cr-benchmark -type f -exec cp {} "$BDIR" \; \
&& find dist-newstyle/ -name crest-sn-benchmark -type f -exec cp {} "$BDIR" \; \
&& find dist-newstyle/ -name lctrs-tagging -type f -exec cp {} "$BDIR" \; \
&& chown "$1:$2" -R "$BDIR" \
# && chown "$1:$2" -R dist-newstyle
# && cabal install -j --enable-executable-static --install-method=copy --installdir=$BDIR --overwrite-policy=always \
# && chown "$1:$2" -R $BDIR
